Index: /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/axis_def_nemo.xml
===================================================================
--- /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/axis_def_nemo.xml	(revision 15075)
+++ /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/axis_def_nemo.xml	(revision 15076)
@@ -29,3 +29,4 @@
   <axis id="section_ice" n_glo="4" />
   <axis id="gau" />
+  <axis id="profsed" long_name="Vertical S levels" unit="cm" positive="down"/>
 </axis_definition>
Index: /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/field_def_nemo-pisces.xml
===================================================================
--- /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 15075)
+++ /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/field_def_nemo-pisces.xml	(revision 15076)
@@ -152,4 +152,5 @@
        <field id="FlxSO4"      long_name="SO4 sediment flux"                       unit="mol/cm2/s"     />
        <field id="FlxFe2"      long_name="Fe2+ sediment flux"                      unit="mol/cm2/s"     />
+       <field id="FlxLig"      long_name="Ligand sediment flux"                    unit="mol/cm2/s"     />
        <field id="dzdep"       long_name="Sedimentation rate"                      unit="cm/s"     />
        <field id="sflxclay"    long_name="Clay sedimentation rate"                 unit="g/cm2/s"     />
@@ -157,4 +158,5 @@
        <field id="sflxpoc"     long_name="POC sedimentation rate"                  unit="g/cm2/s"     />
        <field id="sflxcal"     long_name="Calcite sedimentation rate"              unit="g/cm2/s"     />
+       <field id="sflxfeo"     long_name="Fe(OH)3 Sedimentation rate"              unit="mol/cm2/s"     />
        <field id="FlxClay"     long_name="Clay burial rate"                        unit="g/cm2/s"     />
        <field id="FlxCaCO3"    long_name="Calcite burial rate"                     unit="g/cm2/s"     />
Index: /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/namelist_sediment_ref
===================================================================
--- /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/namelist_sediment_ref	(revision 15075)
+++ /NEMO/branches/2021/dev_r14383_PISCES_NEWDEV_PISCO/cfgs/SHARED/namelist_sediment_ref	(revision 15076)
@@ -12,5 +12,4 @@
 &nam_run      !  Characteristics of the simulation
 !-----------------------------------------------------------------------
-  nrseddt   = 2          ! Nb of iterations for fast species
   ln_sed_2way = .false.  ! 2 way coupling with pisces
 /
@@ -25,5 +24,5 @@
   porsurf = 0.9        ! Sediment porosity at the surface
   porinf  = 0.75       ! Sediment porosity at infinite depth
-  rhox    = 0.33       ! Length scale of porosity variation (cm)
+  rhox    = 0.25       ! Length scale of porosity variation (cm)
 /
 !-----------------------------------------------------------------------
@@ -33,22 +32,23 @@
 !                 !    name   !           title of the field             !   units     ! initial data from file or not !
 !                 !           !                                          !             !
-   sedsol(1)      = 'SedBSi  ' , 'Biogenic Silicate Concentration        ',  '%'
-   sedsol(2)      = 'SedClay ' , 'Clay Concentration                     ',  '%'
+   sedsol(1)      = 'SedFeO  ' , 'Fe(OH)3 Concentration                  ',  '%'
+   sedsol(2)      = 'SedFeS  ' , 'FeS Concentration                      ',  '%'
    sedsol(3)      = 'SedPOC  ' , 'POC Concentration                      ',  '%'
-   sedsol(4)      = 'SedCaCO3' , 'Calcite Concentration                  ',  '%'
-   sedsol(5)      = 'SedPOS  ' , 'Semi-ref POC Concentration             ',  '%'
-   sedsol(6)      = 'SedPOR  ' , 'Refractory POC Concentration           ',  '%'
-   sedsol(7)      = 'SedFeO  ' , 'Fe(OH)3 Concentration                  ',  '%'
-   sedsol(8)      = 'SedFeS  ' , 'FeS Concentration                      ',  '%'
-   sedwat(1)      = 'SedSil  ' , 'Silicate Concentration                 ',  'mol/L' 
-   sedwat(2)      = 'SedO2   ' , 'Dissolved Oxygen Concentration         ',  'mol/L'
-   sedwat(3)      = 'SedDIC  ' , 'Dissolved inorganic Concentration      ',  'mol/L'
-   sedwat(4)      = 'SedNO3  ' , 'Nitrates Concentration                 ',  'mol/L'
-   sedwat(5)      = 'SedPO4  ' , 'Phosphate Concentration                ',  'mol/L'
-   sedwat(6)      = 'SedAlkalini' , 'Total Alkalinity Concentration      ',  'eq/L '
-   sedwat(7)      = 'SedNH4  ' , 'Total Ammonium Concentration           ',  'mol/L '
-   sedwat(8)      = 'SedH2S  ' , 'Total H2S Concentration                ',  'mol/L '
-   sedwat(9)      = 'SedSO4  ' , 'Total SO4 Concentration                ',  'mol/L '
-   sedwat(10)     = 'SedFe2  ' , 'Total Fe2+ Concentration               ',  'mol/L '
+   sedsol(4)      = 'SedPOS  ' , 'Semi-ref POC Concentration             ',  '%'
+   sedsol(5)      = 'SedPOR  ' , 'Refractory POC Concentration           ',  '%'
+   sedsol(6)      = 'SedCaCO3' , 'Calcite Concentration                  ',  '%'
+   sedsol(7)      = 'SedBSi  ' , 'Biogenic Silicate Concentration        ',  '%'
+   sedsol(8)      = 'SedClay ' , 'Clay Concentration                     ',  '%'
+   sedwat(1)      = 'SedO2   ' , 'Dissolved Oxygen Concentration         ',  'mol/L'
+   sedwat(2)      = 'SedNO3  ' , 'Nitrates Concentration                 ',  'mol/L'
+   sedwat(3)      = 'SedPO4  ' , 'Phosphate Concentration                ',  'mol/L'
+   sedwat(4)      = 'SedNH4  ' , 'Total Ammonium Concentration           ',  'mol/L '
+   sedwat(5)      = 'SedH2S  ' , 'Total H2S Concentration                ',  'mol/L '
+   sedwat(6)      = 'SedSO4  ' , 'Total SO4 Concentration                ',  'mol/L '
+   sedwat(7)      = 'SedFe2  ' , 'Total Fe2+ Concentration               ',  'mol/L '
+   sedwat(8)      = 'SedAlkalini' , 'Total Alkalinity Concentration      ',  'eq/L '
+   sedwat(9)      = 'Sedligand  ' , 'Total ligand Concentration          ',  'mol/L '
+   sedwat(10)     = 'SedDIC  ' , 'Dissolved inorganic Concentration      ',  'mol/L'
+   sedwat(11)     = 'SedSil  ' , 'Silicate Concentration                 ',  'mol/L'
 /
 !-----------------------------------------------------------------------
@@ -58,26 +58,26 @@
    seddiag3d(1)   = 'SedpH      ' , 'pH                                     ',  '-      '
    seddiag3d(2)   = 'SedCO3por  ' , 'Dissolved CO3 concentration            ',  'mol/L'
-   seddiag3d(3)   = 'Sedligand  ' , 'ligand concentration                   ',  'mol/L'
-   seddiag3d(4)   = 'SaturCO3   ' , 'CO3 saturation                         ',  '-'
-   seddiag2d(1)   = 'FlxSi      ' , 'Silicate flux                          ',  'mol/cm2/s'
-   seddiag2d(2)   = 'FlxO2      ' , 'Dissolved Oxygen Flux                  ',  'mol/L'
-   seddiag2d(3)   = 'FlxDIC     ' , 'Dissolved inorganic carbon flux        ',  'mol/cm2/s'
-   seddiag2d(4)   = 'FlxNO3     ' , 'Nitrates flux                          ',  'mol/cm2/s'
-   seddiag2d(5)   = 'FlxPO4     ' , 'Phosphate flux                         ',  'mol/cm2/s'
-   seddiag2d(6)   = 'FlxAlkalini' , 'Total Alkalinity flux                  ',  'mol/cm2/s'
-   seddiag2d(7)   = 'FlxNH4     ' , 'Total Ammonium flux                    ',  'mol/cm2/s'
-   seddiag2d(8)   = 'FlxH2S     ' , 'Total H2S flux                         ',  'mol/cm2/s'
-   seddiag2d(9)   = 'FlxSO4     ' , 'Total SO4 flux                         ',  'mol/cm2/s'
-   seddiag2d(10)  = 'FlxFe2     ' , 'Total Fe2+ flux                        ',  'mol/cm2/s'
-   seddiag2d(11)  = 'FlxBSi     ' , 'Total net BSi burial rate              ',  'g/cm2/s'
-   seddiag2d(12)  = 'FlxClay    ' , 'Total net CLay burial rate             ',  'g/cm2/s'
-   seddiag2d(13)  = 'FlxPOC     ' , 'Total net POC burial rate              ',  'g/cm2/s'
-   seddiag2d(14)  = 'FlxCaCO3   ' , 'Total net CaCO3 burial rate            ',  'g/cm2/s'
-   seddiag2d(15)  = 'FlxPOS     ' , 'Total net POS burial rate              ',  'g/cm2/s'
-   seddiag2d(16)  = 'FlxPOR     ' , 'Total net POR burial rate              ',  'g/cm2/s'
-   seddiag2d(17)  = 'FlxFeO     ' , 'Total net FeO burial rate              ',  'g/cm2/s'
-   seddiag2d(18)  = 'FlxFeS     ' , 'Total net FeS burial rate              ',  'g/cm2/s'
-   seddiag2d(19)  = 'Flxtot     ' , 'Total burial flux                      ',  'mol/cm2/s'
-   seddiag2d(20)  = 'dzdep      ' , 'Sedimentation rate                     ',  'cm/s'
+   seddiag3d(3)   = 'SaturCO3   ' , 'CO3 saturation                         ',  '-'
+   seddiag2d(1)   = 'FlxO2      ' , 'Dissolved Oxygen Flux                  ',  'mol/L'
+   seddiag2d(2)   = 'FlxNO3     ' , 'Nitrates flux                          ',  'mol/cm2/s'
+   seddiag2d(3)   = 'FlxPO4     ' , 'Phosphate flux                         ',  'mol/cm2/s'
+   seddiag2d(4)   = 'FlxNH4     ' , 'Total Ammonium flux                    ',  'mol/cm2/s'
+   seddiag2d(5)   = 'FlxH2S     ' , 'Total H2S flux                         ',  'mol/cm2/s'
+   seddiag2d(6)   = 'FlxSO4     ' , 'Total SO4 flux                         ',  'mol/cm2/s'
+   seddiag2d(7)   = 'FlxFe2     ' , 'Total Fe2+ flux                        ',  'mol/cm2/s'
+   seddiag2d(8)   = 'FlxAlkalini' , 'Total Alkalinity flux                  ',  'mol/cm2/s'
+   seddiag2d(9)   = 'FlxLig     ' , 'Total Ligand flux                      ',  'mol/cm2/s'
+   seddiag2d(10)  = 'FlxDIC     ' , 'Dissolved inorganic carbon flux        ',  'mol/cm2/s'
+   seddiag2d(11)  = 'FlxSi      ' , 'Silicate flux                          ',  'mol/cm2/s'
+   seddiag2d(12)  = 'FlxFeO     ' , 'FeO burial flux                        ',  'mol/cm2/s'
+   seddiag2d(13)  = 'FlxFeS     ' , 'FeS burial flux                        ',  'mol/cm2/s'
+   seddiag2d(14)  = 'FlxPOC     ' , 'POC burial flux                        ',  'mol/cm2/s'
+   seddiag2d(15)  = 'FlxPOS     ' , 'POS burial flux                        ',  'mol/cm2/s'
+   seddiag2d(16)  = 'FlxPOR     ' , 'POR burial flux                        ',  'mol/cm2/s'
+   seddiag2d(17)  = 'FlxCaCO3   ' , 'Calcite burial flux                    ',  'mol/cm2/s'
+   seddiag2d(18)  = 'FlxBSi     ' , 'BSi burial flux                        ',  'mol/cm2/s'
+   seddiag2d(19)  = 'FlxClay    ' , 'Clay burial flux                       ',  'mol/cm2/s'
+   seddiag2d(20)  = 'Flxtot     ' , 'Total burial flux                      ',  'mol/cm2/s'
+   seddiag2d(21)  = 'dzdep      ' , 'Sedimentation rate                     ',  'cm/s'
 /
 !-----------------------------------------------------------------------
@@ -100,13 +100,14 @@
    rcorgl   =  10.     ! Reactivity for labile POC [an-1]
    rcorgs   =  0.1     ! Reactivity for semi-refractory POC [an-1]
-   rcorgr   =  5.E-4   ! Reactivity for refractory POC [an-1]
+   rcorgr   =  1.E-4   ! Reactivity for refractory POC [an-1]
    rcnh4    =  1E7     ! Reactivity for O2/NH4 [l.mol-1.an-1]
-   rch2s    =  2E8     ! Reactivity for O2/H2S [l.mol-1.an-1]
-   rcfe2    =  1E8     ! Reactivity for O2/Fe2+ [l.mol-1.an-1]
+   rch2s    =  1E7     ! Reactivity for O2/H2S [l.mol-1.an-1]
+   rcfe2    =  1E9     ! Reactivity for O2/Fe2+ [l.mol-1.an-1]
    rcfeh2s  =  1E4     ! Reactivity for FEOH/H2S [l.mol-1.an-1]
-   rcfes    =  1E6     ! Reactivity for FE2+/H2S [l.mol-1.an-1]
-   rcfeso   =  2E7     ! Reactivity for FES/O2 [l.mol-1.an-1]
-   xksedo2  =  4.E-6   ! Half-saturation constant for oxic remin [mol/l]
-   xksedno3 =  10.E-6  ! Half-saturation constant for denitrification [mol/l] 
+   rcfeso   =  2E6     ! Reactivity for FES/O2 [l.mol-1.an-1]
+   rcfesp   =  5E-6    ! Precipitation of FeS [mol.l-1.an-1]
+   rcfesd   =  1.E-3   ! Dissolution of FeS [an-1]
+   xksedo2  =  1.E-6   ! Half-saturation constant for oxic remin [mol/l]
+   xksedno3 =  5.E-6  ! Half-saturation constant for denitrification [mol/l] 
    xksedfeo =  0.007   ! Half-saturation constant for iron remin [%]
    xksedso4 =  2E-3    ! Half-saturation constant for SO4 remin [mol/l]
@@ -115,8 +116,9 @@
 &nam_btb     !   parameters for bioturbation and bioirrigation
 !-----------------------------------------------------------------------
-   dbiot       =  10.       ! Bioturbation coefficient (in cm2/yr)
+   dbiot       =  8.        ! Bioturbation coefficient (in cm2/yr)
    ln_btbz     =  .true.    ! Depth varying bioturbation 
-   dbtbzsc     =  6.0       ! coefficient for btb attenuation. If no variation, depth of the mixed layer
-   adsnh4      =  1.3       ! Adsorption coefficient of NH4
+   dbtbzsc     =  4.0       ! coefficient for btb attenuation. If no variation, depth of the mixed layer
+   adsnh4      =  4.16      ! Adsorption coefficient of NH4
+   adsfe2      =  0.0       ! Adsorption coefficient of Fe2
    ln_irrig    =  .true.    ! Bioirrigation in sediment
    xirrzsc     =  1.5       ! Vertical scale of the attentuation of bioirrigation [cm]